require 'graphql/rails/active_reflection/model'

module Recline
  class Model < GraphQL::Rails::ActiveReflection::Model
    def self.interface
      @interface ||= GraphQL::InterfaceType.define do
        name "ReclineInterface"
        field('_model', Recline::Types::ModelReflectionType, 'Model of attributes for field.') do
          description('Fetch the content model for the given object.')
          resolve(Recline::ModelReflection)
        end
      end
    end

    def self.field(**kwargs, &block)
      # We have to define it fresh each time because
      # its name will be modified and its description
      # _may_ be modified.
      field = GraphQL::Field.define do
        type(Recline::Model.interface)
        description('Fetch the content model for the given object.')
        resolve(Recline::ModelReflection)
      end

      if kwargs.any? || block
        field = field.redefine(kwargs, &block)
      end

      field
    end
  end
end
