require 'graphql/rails/active_reflection/model_reflection'

class Recline::ModelReflection < GraphQL::Rails::ActiveReflection::ModelReflection
  @schema_name = "ReclineMode"

  attr_reader :versions

  def initialize(obj, ctx)
    super
    @versions = obj.versions if obj.respond_to? :versions
  end

  def get_attributes
    @attributes ||= @type.fields.map { |name, field|
      # No reflection if it's not a model attribute
      property = field.property || name
      if include_property? property
        Recline::AttributeReflection.new(field, @klass, @schema)
      end
    }.compact
  end
end
