module Recline
  class Railtie < Rails::Railtie
    config.before_configuration do
      GraphQL::Field.accepts_definitions(recline_appearance: GraphQL::Define.assign_metadata_key(:recline_appearance))

      begin
        require "paper_trail"
        require "recline/types/version_reflection_type"
        Recline::Types::ModelReflectionType.define do
          field :versions, Recline::Types::VersionReflectionType.to_list_type
        end
      rescue LoadError
        # not installed
      end
    end
  end
end
